#ifndef DisplayRGB_H
#define DisplayRGB_H

//#if ARDUINO >= 100
 #include <Arduino.h>
// #include <Print.h>
//#else
// #include "WProgram.h"
//#endif
#include "settings.c"
#include <SPI.h>
#include <avr/pgmspace.h>

//#ifdef
#include <petit_fatfs.h>
#include <pff.h>
#include <integer.h>
#include <diskio.h>
//#endif

// 16 PREDEFINED COLORS UNCOMMENT AND PASTE TO SKETCH
#define BLACK 0x0000 
#define WHITE 0xFFFF 
//#define DARKGRAY 0xAD55 
//#define GRAY 0x8410
//#define BLUE 0x001F 
//#define DARKBLUE 0x0011 
//#define TURQUOISE 0x471A 
//#define GREEN 0x0400 
//#define FORESTGREEN 0x2444 
//#define YELLOW 0xFFE0 
//#define ORANGE 0xFD20 
//#define PINK 0xFE19 
//#define RED 0xF800 
//#define PURPLE 0x8010 
//#define VIOLET 0xEC1D 
//#define BROWN 0xA145
//#define BEIGE 0xF7BB

#if defined(__SD_H__)  // Arduino SD library
#include "PImage.h"
//#else
//#warning "The SD library was not found. loadImage() and image() won't be supported."
#endif

//colors


//for extended bitmap function :
#define NOROT 0
#define ROTCCW 1
#define ROT180 2
#define ROTCW 3
#define NOFLIP 0
#define FLIPH 1
#define FLIPV 2
#define FLIPVH 3

#if (DISPLAY_ROT == NO_ROT)||(DISPLAY_ROT == ROT180) //landscape mode
#define LCDWIDTH 220
#define LCDHEIGHT 176
#else //portrait mode
#define LCDWIDTH 176
#define LCDHEIGHT 220
#endif
#define LCDHEIGHT_NOROT 176
#define LCDWIDTH_NOROT 220

#define swap(a, b) { int8_t t = a; a = b; b = t; }

#define PCD8544_SETYADDR 0x40
#define PCD8544_SETXADDR 0x80
#define PCD8544_SETXADDR 0x80


extern uint8_t _displayBuffer[];

typedef uint16_t color;

class Display : public Print 
{
	public:
		void tftBegin(uint8_t cs,uint8_t wr ,uint8_t rs , uint8_t rest ,uint8_t pmw );
		
		//void command(uint8_t c);

		void write_spi(const uint8_t data);
        inline void drawPixel(int16_t x, int16_t y, uint16_t color);
		//inline void drawPixelA(int8_t x, int8_t y);   //duhjoker from gamebuino 
	   // inline uint8_t getPixel(int8_t x, int8_t y, uint16_t color);
		void setdatapin(uint8_t b0,uint8_t b1, uint8_t b2 , uint8_t b3, uint8_t b4, uint8_t b5, uint8_t b6, uint8_t b7);
		void setbacklight(uint8_t pmw);
		
		uint8_t* getBuffer(); //duhjoker from gamebuino

		void clear(void);

		void begin();

		void drawLine(int16_t x0, int16_t y0, int16_t x1, int16_t y1, uint16_t color);
		void drawFastVLine(int16_t x, int16_t y, int16_t h, uint16_t);
		void drawFastHLine(int16_t x, int16_t y, int16_t w, uint16_t color);
		void drawRect(int16_t x, int16_t y, int16_t w, int16_t h, uint16_t color);
	    void fillRect(int16_t x, int16_t y, int16_t w, int16_t h, uint16_t color);
		void fillScreen(uint16_t color);
		void invertDisplay(boolean i);

		void drawCircle(int16_t x0, int16_t y0, int16_t r, uint16_t color);
		void drawCircleHelper(int16_t x0, int16_t y0, int16_t r, uint8_t cornername, uint16_t color);
		void fillCircle(int16_t x0, int16_t y0, int16_t r, uint16_t color);
		void fillCircleHelper(int16_t x0, int16_t y0, int16_t r, uint8_t cornername, int16_t delta, uint16_t color);

		void drawTriangle(int16_t x0, int16_t y0, int16_t x1, int16_t y1, int16_t x2, int16_t y2, uint16_t color);
		void fillTriangle(int16_t x0, int16_t y0, int16_t x1, int16_t y1, int16_t x2, int16_t y2, uint16_t color);
		void drawRoundRect(int16_t x0, int16_t y0, int16_t w, int16_t h, int16_t radius, uint16_t color);
		void fillRoundRect(int16_t x0, int16_t y0, int16_t w, int16_t h, int16_t radius, uint16_t color);

		//adafruit_gfx not worth much with out tilemap optimazation 
		void drawBitmap1(int16_t x, int16_t y, const uint8_t *bitmap, int16_t w, int16_t h, uint16_t color);
		void drawBitmap2(int16_t x, int16_t y, const uint8_t *bitmap, int16_t w, int16_t h, uint16_t color, uint16_t bg);
		void drawBitmap3(int16_t x, int16_t y, uint8_t *bitmap, int16_t w, int16_t h, uint16_t color);
		void drawBitmap4(int16_t x, int16_t y, uint8_t *bitmap, int16_t w, int16_t h, uint16_t color, uint16_t bg);
		void drawXBitmap(int16_t x, int16_t y, const uint8_t *bitmap, int16_t w, int16_t h, uint16_t color);

		//GAMEBUINO----SUMMONER123
		void drawBitmap(int8_t x, int8_t y, int8_t w, int8_t h, const uint8_t *bitmap, uint8_t dx, uint8_t dy, uint8_t dw, uint8_t dh, uint16_t color);
		boolean getBitmapPixel(const uint8_t* bitmap, uint8_t x, uint8_t y);

		//draw from SD  mouguino    
		//Draw bitmap from SD at position x0, y0
		void drawBitmapFromSdA(byte x, byte y, char *bitmap, uint16_t color);
		void drawBitmapFromSdB(byte x, byte y, byte w, byte h, const uint8_t *bitmap, byte dx, byte dy, byte dw, byte dh, uint16_t color);
        int drawBitmapFromSd(byte x0, byte y0, char *bitmap, uint16_t color);
		
		//void updateSlide();

		//GAMEBUINO----SUMMONER123
		void drawTilemap(int x, int y, const uint8_t *tilemap, const uint8_t **spritesheet, uint16_t color);
		void drawTilemap(int x, int y, const uint8_t *tilemap, const uint8_t **spritesheet, uint8_t dx, uint8_t dy, uint8_t dw, uint8_t dh, uint16_t color);

		//void drawTilemap1(int x, int y, const uint8_t *tilemap, const uint8_t **spritesheet, uint8_t dx, uint8_t dy, uint8_t dw, uint8_t dh, uint16_t color);

		void setFont(const uint8_t* f); //duhjoker from gamebuino 
		uint8_t fontWidth, fontHeight;  //duhjoker from gamebuino 

        void drawChar(int16_t x, int16_t y, unsigned char c, uint16_t color, uint16_t bg, uint8_t size);
		void setCursor(int16_t x, int16_t y);
		void setColor(uint16_t color );                //DUHJOKER COLOR LCD SPECIFIC.... USE BEFORE DRAWBITMAP AND TILEMAP FUNCTIONS
//		void setColor(uint16_t color , uint16_t color);   //DUHJOKER COLOR LCD SPECIFIC.... USE BEFORE DRAWBITMAP AND TILEMAP FUNCTIONS
		void setTextColor(uint16_t c);
		void setTextColor(uint16_t c, uint16_t bg);
		void setTextSize(uint8_t s);
		void setTextWrap(boolean w);
		void setRotation(uint8_t r);
		
		virtual size_t write(uint8_t);

        boolean persistence; //disable clean() at each frame if true
		boolean textWrap; // If set, 'wrap' text at right edge of 
		uint8_t fontSize;
		int8_t cursorX, cursorY;
		byte contrast;
		byte frameCount;

		typedef struct {       //line 171 "Public Variables   - ADD by Summoner123
			int x;                    //X coordinate                 - ADD by Summoner123
			int y;                    //Y coordinate                 - ADD by Summoner123
			const byte *spritecol;    //Sprite of object             - ADD b Summoner123
		}object;
		object solid[60];         // Matriz were saved a Sprite, X and Y cordinates of all tiles on the screen - ADD by Summoner123

		byte numcolision = 0;     //count of solid objects indacat how many tiles drawed on the screen - ADD by Summoner123

		bool flagcollision = true;

		int16_t
			height(void),
			width(void);

         uint8_t getRotation(void);

#if defined(__SD_H__)  // Arduino SD library
		PImage loadImage(const char * fileName) { return PImage::loadImage(fileName); }

		void image(PImage & img, uint16_t x, uint16_t y);
#endif

protected:
	int16_t
		WIDTH, HEIGHT;   // this is the 'raw' display w/h - never changes
	int16_t
		_width, _height, // dependent on rotation
		cursor_x, cursor_y;
	uint16_t
		textcolor, textbgcolor;
	uint8_t
		textsize,
		rotation;
	boolean
		wrap; // If set, 'wrap' text at right edge of display
			  /*
			  * Processing-style graphics state
			  */

	//color strokeColor;
	//bool useStroke;
	//color fillColor;
	bool useFill;
		
//fuction
	private:
		void set_window(uint8_t x1,uint8_t y1,uint8_t x2,uint8_t y2);
		void write_wr_reg(uint16_t data);
		void write_wr_data(uint16_t data);
		void write_cmd(uint16_t cmd ,uint16_t data);
		#if 0 //defined(ARDUINO_ARCH_SAM)
			void write_delay();
		#else
			#define write_delay()  
		#endif
		
//value	
	//private:
	
	#if defined(ARDUINO_ARCH_SAM)
		uint32_t _cs;
		uint32_t _pmw;
		uint32_t _wr;
		uint32_t _rs;
		uint32_t _rest;
		
		volatile uint32_t *csport;
		volatile uint32_t *pmwport;
		volatile uint32_t *wrport;
		volatile uint32_t *rsport;
		volatile uint32_t *restport;
		
		uint32_t cspinmask;
		uint32_t pmwpinmask;
		uint32_t wrpinmask;
		uint32_t rspinmask;
		uint32_t restpinmask;
		
		volatile uint32_t data[8];
		volatile uint32_t datapinmask[8];
		volatile uint32_t* dataport[8];	
			
	#else
		uint8_t _cs;
		uint8_t _pmw;
		uint8_t _wr;
		uint8_t _rs;
		uint8_t _rest;
		
		volatile uint8_t *csport;
		volatile uint8_t *pmwport;
		volatile uint8_t *wrport;
		volatile uint8_t *rsport;
		volatile uint8_t *restport;
		
		uint8_t cspinmask;
		uint8_t pmwpinmask;
		uint8_t wrpinmask;
		uint8_t rspinmask;
		uint8_t restpinmask;
		
		volatile uint8_t data[8];
		volatile uint8_t datapinmask[8];
		volatile uint8_t* dataport[8];
	
	#endif

		uint8_t *font;
};

inline uint8_t* Display::getBuffer() {
	return _displayBuffer;
}

inline void Display::drawPixel(int16_t x, int16_t y, uint16_t color)
{
	set_window(x, y, x, y);
	//this->write_wr_reg(0x0022);
	//this->write_wr_data(color);
	this->write_cmd(0x22, color);
}

#if defined(__SD_H__)  // Arduino SD library

#define BUFFPIXEL 20

void Adafruit_GFX::image(PImage & img, uint16_t x, uint16_t y) {
	int      w, h, row, col;
	uint8_t  r, g, b;
	uint32_t pos = 0;
	uint8_t  sdbuffer[3 * BUFFPIXEL]; // pixel buffer (R+G+B per pixel)
	uint8_t  buffidx = sizeof(sdbuffer); // Current position in sdbuffer

										 // Crop area to be loaded
	w = img._bmpWidth;
	h = img._bmpHeight;
	if ((x + w - 1) >= width())  w = width() - x;
	if ((y + h - 1) >= height()) h = height() - y;

	/*
	// Set TFT address window to clipped image bounds
	setAddrWindow(x, y, x+w-1, y+h-1);
	*/

	for (row = 0; row<h; row++) { // For each scanline...
								  // Seek to start of scan line.  It might seem labor-
								  // intensive to be doing this on every line, but this
								  // method covers a lot of gritty details like cropping
								  // and scanline padding.  Also, the seek only takes
								  // place if the file position actually needs to change
								  // (avoids a lot of cluster math in SD library).
		if (img._flip) // Bitmap is stored bottom-to-top order (normal BMP)
			pos = img._bmpImageoffset + (img._bmpHeight - 1 - row) * img._rowSize;
		else     // Bitmap is stored top-to-bottom
			pos = img._bmpImageoffset + row * img._rowSize;
		if (img._bmpFile.position() != pos) { // Need seek?
			img._bmpFile.seek(pos);
			buffidx = sizeof(sdbuffer); // Force buffer reload
		}

		for (col = 0; col<w; col++) { // For each pixel...
									  // Time to read more pixel data?
			if (buffidx >= sizeof(sdbuffer)) { // Indeed
				img._bmpFile.read(sdbuffer, sizeof(sdbuffer));
				buffidx = 0; // Set index to beginning
			}

			// Convert pixel from BMP to TFT format, push to display
			b = sdbuffer[buffidx++];
			g = sdbuffer[buffidx++];
			r = sdbuffer[buffidx++];
			//pushColor(tft.Color565(r,g,b));
			drawPixel(x + col, y + row, newColor(r, g, b));

		} // end pixel
	} // end scanline

}




// These read 16- and 32-bit types from the SD card file.
// BMP data is stored little-endian, Arduino is little-endian too.
// May need to reverse subscript order if porting elsewhere.

uint16_t PImage::read16(File f) {
	uint16_t result;
	((uint8_t *)&result)[0] = f.read(); // LSB
	((uint8_t *)&result)[1] = f.read(); // MSB
	return result;
}

uint32_t PImage::read32(File f) {
	uint32_t result;
	((uint8_t *)&result)[0] = f.read(); // LSB
	((uint8_t *)&result)[1] = f.read();
	((uint8_t *)&result)[2] = f.read();
	((uint8_t *)&result)[3] = f.read(); // MSB
	return result;
}


PImage PImage::loadImage(const char * fileName) {
	File     bmpFile;
	int      bmpWidth, bmpHeight;   // W+H in pixels
	uint8_t  bmpDepth;              // Bit depth (currently must be 24)
	uint32_t bmpImageoffset;        // Start of image data in file
	uint32_t rowSize;               // Not always = bmpWidth; may have padding
	bool     flip = true;        // BMP is stored bottom-to-top


								 // Open requested file on SD card
	if ((bmpFile = SD.open(fileName)) == NULL) {
		Serial.print(F("loadImage: file not found: "));
		Serial.println(fileName);
		return PImage(); // load error
	}



	// Parse BMP header
	if (read16(bmpFile) != 0x4D42) { // BMP signature
		Serial.println(F("loadImage: file doesn't look like a BMP"));
		return PImage();
	}

	Serial.print(F("File size: ")); Serial.println(read32(bmpFile));
	(void)read32(bmpFile); // Read & ignore creator bytes
	bmpImageoffset = read32(bmpFile); // Start of image data
	Serial.print(F("Image Offset: ")); Serial.println(bmpImageoffset, DEC);
	// Read DIB header
	Serial.print(F("Header size: ")); Serial.println(read32(bmpFile));
	bmpWidth = read32(bmpFile);
	bmpHeight = read32(bmpFile);
	if (read16(bmpFile) != 1) { // # planes -- must be '1'
		Serial.println(F("loadImage: invalid n. of planes"));
		return PImage();
	}

	bmpDepth = read16(bmpFile); // bits per pixel
	Serial.print(F("Bit Depth: ")); Serial.println(bmpDepth);
	if ((bmpDepth != 24) || (read32(bmpFile) != 0)) { // 0 = uncompressed {
		Serial.println(F("loadImage: invalid pixel format"));
		return PImage();
	}

	Serial.print(F("Image size: "));
	Serial.print(bmpWidth);
	Serial.print('x');
	Serial.println(bmpHeight);

	// BMP rows are padded (if needed) to 4-byte boundary
	rowSize = (bmpWidth * 3 + 3) & ~3;

	// If bmpHeight is negative, image is in top-down order.
	// This is not canon but has been observed in the wild.
	if (bmpHeight < 0) {
		bmpHeight = -bmpHeight;
		flip = false;
	}

	return PImage(bmpFile, bmpWidth, bmpHeight, bmpDepth, bmpImageoffset, rowSize, flip);
}

#endif



uint16_t RGB(uint16_t r, uint16_t g , uint16_t b);

#endif 